unit Autostart_unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids;

type

  { TAutostartForm }

  TAutostartForm = class(TForm)
    Autostart1_grid: TStringGrid;
    Autostart2_grid: TStringGrid;
    BT_OK: TButton;
    Aktualisieren: TButton;
    Ed_etcautostart: TEdit;
    ED_homeautostart: TEdit;
    procedure AktualisierenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  AutostartForm: TAutostartForm;

implementation

{$R *.lfm}

{ TAutostartForm }

procedure TAutostartForm.AktualisierenClick(Sender: TObject);
var
  Found,n,m : Integer;
  p1,p2     : Integer;
  SearchRec : TSearchRec;
  Pfad      : String;
  Datei     : TStringList;
begin
  Datei := TStringList.create;
  Pfad := ED_homeautostart.text;
  Autostart1_Grid.Cells[1,0] := 'Name';
  Autostart1_Grid.Cells[2,0] := 'enabled';
  Found := FindFirst(Pfad+'/*', faDirectory, SearchRec);
  n := 1;
  Autostart1_Grid.RowCount :=n+1;
  Autostart1_Grid.ColWidths[1] := 500;
  while Found = 0 do
    begin
      if (SearchRec.Name <> '..') and  (SearchRec.Name <> '.') then
        Begin
          Autostart1_Grid.Cells[1,n] := SearchRec.Name;
          Autostart1_Grid.cells[0,n] := IntToStr(n);
          if Fileexists(Pfad+'/'+SearchRec.Name) then
            Begin
              Datei.loadfromfile(Pfad+'/'+SearchRec.Name);
              For m := 0 to Datei.count-1 do
                Begin
                  p1 := pos('X-GNOME-Autostart-enabled',Datei[m]);
                  p2 := pos('=',Datei[m]);
                  if (p1=1) and (p2>0) then
                    Begin
                      Autostart1_Grid.Cells[2,n] := Trim(Copy(Datei[m],p2+1,length(Datei[m])-p2));
                    end;
                end;
            end;
          inc(n);
          Autostart1_Grid.RowCount :=n+1;
        end;
      Found := FindNext(SearchRec);
    end;
  FindClose(SearchRec);
  Autostart1_Grid.RowCount :=n;
  Pfad := ED_etcautostart.text;
  Autostart2_Grid.Cells[1,0] := 'Name';
  Autostart2_Grid.Cells[2,0] := 'enabled';
  Found := FindFirst(Pfad+'/*', faDirectory, SearchRec);
  n := 1;
  Autostart2_Grid.RowCount :=n+1;
  Autostart2_Grid.ColWidths[1] := 500;
  while Found = 0 do
      begin
        if (SearchRec.Name <> '..') and  (SearchRec.Name <> '.') then
          Begin
            Autostart2_Grid.Cells[1,n] := SearchRec.Name;
            if Fileexists(Pfad+'/'+SearchRec.Name) then
              Begin
                Datei.loadfromfile(Pfad+'/'+SearchRec.Name);
                For m := 0 to Datei.count-1 do
                  Begin
                    p1 := pos('X-GNOME-Autostart-enabled',Datei[m]);
                    p2 := pos('=',Datei[m]);
                    if (p1=1) and (p2>0) then
                      Begin
                        Autostart2_Grid.Cells[2,n] := Trim(Copy(Datei[m],p2+1,length(Datei[m])-p2));
                      end;
                  end;
              end;
            inc(n);
            Autostart2_Grid.RowCount :=n+1;
          end;
        Found := FindNext(SearchRec);
      end;
  FindClose(SearchRec);
  Autostart2_Grid.RowCount :=n;
  Datei.free;
  Autostart1_grid.SortOrder := soAscending;
  Autostart1_grid.SortColRow(true,1,1,Autostart1_grid.rowcount-1);
  for n := 1 to Autostart1_grid.rowcount-1 do Autostart1_Grid.cells[0,n] := IntToStr(n);
  Autostart2_grid.SortOrder := soAscending;
  Autostart2_grid.SortColRow(true,1,1,Autostart2_grid.rowcount-1);
  for n := 1 to Autostart2_grid.rowcount-1 do Autostart2_Grid.cells[0,n] := IntToStr(n);
end;

procedure TAutostartForm.FormShow(Sender: TObject);
begin
  AktualisierenClick(nil);
end;

end.

