unit iddsa_unit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, base;

type

  { Tiddsa_form }

  Tiddsa_form = class(TForm)
    Beenden: TButton;
    ClearKnownHosts: TCheckBox;
    KeyImport: TButton;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    procedure BeendenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure KeyImportClick(Sender: TObject);
   private
    { private declarations }
  public
    keytype : integer;
    { public declarations }
  end;
Const
  keyPfad = '/root/.ssh/authorized_keys';

var
  iddsa_form: Tiddsa_form;
  sshd_config_Warning : Boolean;

implementation

{$R *.lfm}

{ Tiddsa_form }

procedure Tiddsa_form.FormShow(Sender: TObject);

begin
  RadioGroup1.items.Clear;
  If (du_byte(KeyPfad)>0) then
    Begin
      RadioGroup1.items.Add('dsa-Key des Servers als einzigen Key importieren (andere Keys werden gelöscht)');
      RadioGroup1.items.Add('dsa-Key des Servers zu den vorhandenen Keys hinzufügen');
    end
  else
    Begin
      RadioGroup1.items.Add('dsa-Key des Servers als einzigen Key importieren (keine anderen Keys vorhanden)');
    end;
  if sshd_config_warning then ShowMessage('Hinweis:'+ret+ret+'Der sshd-Service scheint nicht korrekt installiert zu sein'+ret+
                              'oder die "/etc/ssh/sshd.conf" - Datei ist nicht korrekt.'+ret+
                              'Überprüfen Sie das und starten ggf. den Client neu.'+ret+ret+
                              'Das Login über den importierten Key wird deshalb u.U. nicht funktionieren.');
  RadioGroup1.ItemIndex:=0;
end;

procedure Tiddsa_form.BeendenClick(Sender: TObject);
begin
  close;
end;

procedure Tiddsa_form.KeyImportClick(Sender: TObject);
Const
  bef1 = 'sh -c "/bin/cat /root/.ssh/id_dsa_pub_vom_server.tmp >> /root/.ssh/authorized_keys"';
  bef2 = 'rm -f /root/.ssh/id_dsa_pub_vom_server.tmp';
  bef3 = 'chmod 600 /root/.ssh/authorized_keys';
  bef4 = 'rm -f /root/.ssh/known_hosts';
Var
  s,scp1,scp2 : String;
  keyname : String;
  groesse : integer;
begin
  if keytype = 1 then keyname := 'id_ecdsa.pub'
                 else keyname := 'id_dsa.pub';
  if ClearKnownHosts.checked then
        Begin
          s := Befehl_exec(bef4);
        end;
  if RadioGroup1.ItemIndex=0 then
    begin
      scp1 := 'xterm -e "scp root@'+ServerIP+':/root/.ssh/'+keyname+' /root/.ssh/authorized_keys"';
      s := Befehl_exec(scp1);
      If (du_byte(KeyPfad)>0) then ShowMessage('Key wurde importiert.')
                              else ShowMessage('Es trat ein Fehler beim Kopieren des Keys auf.'+ret+
                                               'Der Key wurde nicht importiert.'+ret+ret+
                                               'Import bitte manuell durchführen.');
      s := Befehl_exec(bef3);
    end
  else
    begin
      groesse := du_byte(KeyPfad);
      scp2 := 'xterm -e "scp root@'+ServerIP+':/root/.ssh/'+keyname+' /root/.ssh/id_dsa_pub_vom_server.tmp"';
      s := Befehl_exec(scp2);
      s := Befehl_exec(bef1);
      s := Befehl_exec(bef2);
      If (du_byte(KeyPfad)>groesse) then ShowMessage('Key wurde importiert.')
                                    else ShowMessage('Es trat ein Fehler beim Kopieren des Keys auf.'+ret+
                                                                   'Der Key wurde nicht importiert.'+ret+ret+
                                                                   'Import bitte manuell durchführen.');
      s := Befehl_exec(bef3);
    end;
end;


end.

