unit nautilusunit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, Forms, Controls, Graphics, Dialogs,
  StdCtrls,base,Process;

type

  { TNautilusform }

  TNautilusform = class(TForm)
    Speichern: TButton;
    Abbrechen: TButton;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    SynEdit1: TSynEdit;
    procedure CBChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    Partlist, Info    : TStringList;
    CB                : Array[1..20] of TCheckBox;
    anz               : integer;
  public
    { public declarations }
  end;

var
  Nautilusform: TNautilusform;

implementation

{$R *.lfm}

{ TNautilusform }

procedure TNautilusform.FormShow(Sender: TObject);
Var
  Befehl      : TProcess;
  Ausgabe     : TStringList;
  Zeile       : TStringList;
  fstab       : TStringList;
  n,m         : integer;
  Partition,s,s1 : String;
begin
  Befehl   := TProcess.Create(nil);
  Ausgabe  := TStringList.create;
  Befehl.commandline := '/sbin/fdisk -l';
  Befehl.Options := Befehl.Options + [poWaitOnExit, poUsePipes];
  Befehl.Execute;
  Ausgabe.LoadFromStream(Befehl.Output);
  Befehl.free;
  fstab  := TStringList.create;
  fstab.LoadFromFile('/etc/fstab');
  anz := 0;
  Zeile := TStringList.create;
  PartList.clear;
  Info.clear;
  for n := 0 to Ausgabe.count-1 do
    begin
      if Pos ('/dev/',Ausgabe[n])=1 then
        Begin
          inc(anz);
          Split(' ',Ausgabe[n],Zeile);
          if Zeile[1]='*' then Zeile.Delete(1);
          PartList.append(Zeile[0]);
          if Zeile.count>6 then
            Begin
              If Zeile[6]='Swap' then Info.append(Zeile[6]+' (Id='+Zeile[4]+')')
                                 else Info.append(Zeile[5]+' (Id='+Zeile[4]+')');
            end
           else
             begin
               Info.append(Zeile[5]+' (Id='+Zeile[4]+')');
             end;
           CB[anz] := TCheckBox.create(self);
           CB[anz].parent := self;
           CB[anz].left := 10;
           CB[anz].top := anz*25+30;
           CB[anz].Width:=100;
           CB[anz].caption := PartList[anz-1] + '   '+Info[anz-1];
           CB[anz].onChange := nil;
           CB[anz].tag := anz;
           if (Zeile[4] = '5') or (Zeile[4] = '82') then CB[anz].enabled := false
                                                    else CB[anz].enabled := true;
           for m := 0 to fstab.Count-1 do
             Begin
               s := Trim(fstab[m]);
               if Pos(PartList[anz-1],s) = 1 then
                 Begin
                   CB[anz].enabled := false;
                   Split(' ',s,Zeile);
                   s1 := '';
                   if (Zeile.count>1) then s1 := Zeile[1];
                   CB[anz].caption := CB[anz].caption+', fstab: "'+Zeile[1]+'"';
                 end;
             end;
        end;
    end;
  For n := 0 to synedit1.Lines.Count-1 do
    Begin
      if Pos('KERNEL=="',Synedit1.Lines[n])=1 then
        Begin
          Split('"',Synedit1.Lines[n],Zeile);
          Partition := Zeile[1];
          for m := 1 to anz do
            Begin
              if Pos(Partition, PartList[m-1])> 0 then CB[m].checked := True;
            end
        end;
    end;
  for n := 1 to anz do CB[n].onChange := @CBChange;
  Zeile.free;
  Ausgabe.free;
  fstab.free;
end;

procedure TNautilusform.FormCreate(Sender: TObject);
begin
  PartList := TStringList.create;
  Info := TStringList.create;
end;

procedure TNautilusform.FormClose(Sender: TObject; var CloseAction: TCloseAction
  );
Var n : integer;
begin
  for n := 1 to anz do CB[n].free;
end;

procedure TNautilusform.CBChange(Sender: TObject);
var
   t,n,z : integer;
   c     : Boolean;
   Partition,P : String;
   Zeile : TStringList;
begin
  Zeile := TStringList.create;
  t := (Sender as TCheckBox).tag;
  c := (Sender as TCheckBox).checked;
  Partition := Copy(partList[t-1],6,length(partList[t-1])-5);
  z := -1;
  For n := 0 to synedit1.Lines.Count-1 do
    Begin
      if Pos('KERNEL=="',Synedit1.Lines[n])=1 then
        Begin
          Split('"',Synedit1.Lines[n],Zeile);
          if Zeile[1]=Partition then z := n;
        end;
    end;
  if c and (z=-1) then
    Begin
      Synedit1.lines.Append('KERNEL=="'+Partition+'", ENV{UDISKS_IGNORE}="1"');
    end;
  if (not c) and (z<>-1) then
    Begin
      Synedit1.lines.Delete(z);
    end;
  Zeile.free;
end;

end.

