unit pingedit;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Grids;

type

  { TPingEditForm }

  TPingEditForm = class(TForm)
    BTBeenden: TButton;
    BTHinzufuegen: TButton;
    Edit1: TEdit;
    Edit2: TEdit;
    Memo1: TMemo;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StringGrid1: TStringGrid;
    procedure BTBeendenClick(Sender: TObject);
    procedure BTHinzufuegenClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    PingList: TStringList;
  end;

var
  PingEditForm: TPingEditForm;

implementation

{$R *.lfm}

{ TPingEditForm }

procedure TPingEditForm.FormShow(Sender: TObject);
Var
  n, pinganz,p : Integer;
  Info, Ziel   : String;
begin
  StringGrid1.ColWidths[0] := 100;
  StringGrid1.ColWidths[1] := 305;
  StringGrid1.Cells[1,0] := 'Ziel Adresse (URL oder IP)';
  PingAnz := pinglist.Count;
  if PingAnz >0 then
    Begin
      StringGrid1.rowCount := PingAnz+1;
      for n := 1 to PingAnz do
        Begin
          p := pos(',',PingList[n-1]);
          Info := Copy(PingList[n-1],1,p-1);
          Ziel := Copy(PingList[n-1],p+1,length(PingList[n-1]));
          StringGrid1.cells[0,n] := Info;
          StringGrid1.cells[1,n] := Ziel;
       end;
    end
  else
    Begin
      StringGrid1.rowCount := 1;
    end;
end;


procedure TPingEditForm.BTBeendenClick(Sender: TObject);
Var
  n,p : Integer;
begin
  for n := 1 to StringGrid1.RowCount-1 do
    Begin
      p := Pos(',',StringGrid1.cells[0,n]);
      if (p>0) then
        Begin
          StringGrid1.cells[0,n]:=Copy(StringGrid1.cells[0,n],1,p-1);
        end;
      p := Pos(',',StringGrid1.cells[1,n]);
      if (p>0) then
        Begin
          StringGrid1.cells[1,n]:=Copy(StringGrid1.cells[1,n],1,p-1);
        end;
     end;
  PingList.Clear;
  for n := 1 to StringGrid1.RowCount-1 do
    Begin
      if Trim(StringGrid1.cells[1,n])<>'' then
        Begin
          PingList.Add(StringGrid1.cells[0,n]+','+StringGrid1.cells[1,n]);
        end;
    end;
  close
end;


procedure TPingEditForm.BTHinzufuegenClick(Sender: TObject);
begin
  if (Edit1.text <>'') and (Edit2.text <>'') then
    Begin
      if (Pos(',',Edit1.text)>0) or (Pos(',',Edit2.text)>0) then ShowMessage('Bitte keine Kommas verwenden!')
      else
        Begin
          PingList.add(Edit1.text+','+Edit2.text);
          FormShow(nil);
        end;
    end;
end;

end.

